import re, { memo as V, useState as E, useEffect as z, useRef as Ke, Fragment as ne } from "react";
function Ze(r, t) {
  const i = parseFloat(t[0]);
  return r = r || "", (isNaN(r) ? r.length : parseFloat(r)) >= i;
}
function Xe(r, t) {
  const i = parseFloat(t[0]);
  r = r || "";
  const a = isNaN(r) ? r.length : parseFloat(r);
  return isNaN(a) ? !0 : a <= i;
}
function Ct(r, t) {
  return Ze(r, [t[0]]) && Xe(r, [t[1]]);
}
function Tt(r) {
  return r && /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(r);
}
function St(r) {
  return r == null || r === "undefined" || r === "null" || r === null || Number.isNaN(r) ? !1 : typeof r == "string" ? r.replace(/\s/g, "").length > 0 : typeof r == "object" ? r.length > 0 : !0;
}
function kt(r) {
  return /(https?|ftp|git|svn):\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{1,256}\.[a-z]{2,63}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)/i.test(r);
}
function Ot(r, t) {
  return r === t[0];
}
function Ft(r) {
  const t = ["Bytes", "KB", "MB", "GB", "TB"];
  if (r === 0)
    return "n/a";
  const i = Math.floor(Math.log(r) / Math.log(1024)), a = parseInt(i.toString(), 10);
  return a === 0 ? `${r} ${t[a]})` : `${(r / 1024 ** a).toFixed(1)} ${t[a]}`;
}
function Qe(r) {
  const t = r.name.split(".");
  return t[t.length - 1].toLowerCase();
}
function Pt(r, t) {
  return !!t.includes(Qe(r));
}
function jt(r, t) {
  const i = parseFloat(t) * 1024 * 1024;
  return !(r.size > i);
}
const It = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  between: Ct,
  email: Tt,
  max: Xe,
  min: Ze,
  required: St,
  url: kt,
  equal: Ot,
  bytesToSize: Ft,
  getFileExtension: Qe,
  extensions: Pt,
  maxSize: jt
}, Symbol.toStringTag, { value: "Module" })), Be = It;
async function Nt(r, t) {
  let { value: i, rules: a } = r, c = !0, p, f = [], u;
  return a ? (await Promise.all(
    a.map(async (o) => {
      if (o === "file")
        i && Object.keys(i).map((d) => {
          r.file && Object.entries(r.file).map(([l, g]) => {
            c = Be[l].call(null, i[d], g), c || (f = [...f, l]);
          });
        });
      else {
        if (typeof o == "function")
          c = await o.call(null, t), p = o.name;
        else if (typeof o == "object")
          c = await o.fnc(t), p = o.name;
        else {
          const d = o.split(/:/g);
          p = d.shift(), c = Be[p].call(null, i, d);
        }
        c || (f = [...f, p]);
      }
    })
  ), u = { errors: f, dirty: f.length > 0 }) : u = { errors: f, dirty: !1 }, r.validation = u, r;
}
async function ye(r, t) {
  const i = r.find(
    (c) => c.form_name === t.form_name
  );
  let a = [];
  return i ? a = r.map(
    (c) => c.form_name === t.form_name ? t : c
  ) : a = [...r, t], a;
}
async function At(r, t, i) {
  const a = r.preprocess;
  return r = await (a == null ? void 0 : a.call(null, r, t, i)), r;
}
async function _e(r, t, i) {
  var a;
  return t.preprocess && (t = await At(t, r.fields, i), i[`${t.name}`] = (a = t.value) != null ? a : null), t.rules && (t = await Nt(t, i)), t;
}
function vr(r, t) {
  return r.indexOf(t) != -1;
}
function ae(r) {
  return !!(r.rules && r.rules.length > 0);
}
function Dt(r) {
  let t = {};
  return r.some(function(i) {
    return t.hasOwnProperty(i.name) || t.hasOwnProperty(i.attributes.id) ? !0 : (t[i.name] = !1, t[i.attributes.id] = !1);
  });
}
function pr(r) {
  const t = (i) => {
    r && !r.contains(i.target) && !i.defaultPrevented && r.dispatchEvent(new CustomEvent("click_outside", r));
  };
  return document.addEventListener("click", t, !0), {
    destroy() {
      document.removeEventListener("click", t, !0);
    }
  };
}
function Re(r, t) {
  var i, a;
  return re.createElement(
    (i = t.tag) != null ? i : "div",
    { className: (a = t.classes) == null ? void 0 : a.join(" ") },
    r
  );
}
var ce = { exports: {} }, ee = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Ue;
function $t() {
  if (Ue)
    return ee;
  Ue = 1;
  var r = re, t = Symbol.for("react.element"), i = Symbol.for("react.fragment"), a = Object.prototype.hasOwnProperty, c = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, p = { key: !0, ref: !0, __self: !0, __source: !0 };
  function f(u, o, d) {
    var l, g = {}, v = null, j = null;
    d !== void 0 && (v = "" + d), o.key !== void 0 && (v = "" + o.key), o.ref !== void 0 && (j = o.ref);
    for (l in o)
      a.call(o, l) && !p.hasOwnProperty(l) && (g[l] = o[l]);
    if (u && u.defaultProps)
      for (l in o = u.defaultProps, o)
        g[l] === void 0 && (g[l] = o[l]);
    return { $$typeof: t, type: u, key: v, ref: j, props: g, _owner: c.current };
  }
  return ee.Fragment = i, ee.jsx = f, ee.jsxs = f, ee;
}
var te = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Ge;
function Lt() {
  return Ge || (Ge = 1, process.env.NODE_ENV !== "production" && function() {
    var r = re, t = Symbol.for("react.element"), i = Symbol.for("react.portal"), a = Symbol.for("react.fragment"), c = Symbol.for("react.strict_mode"), p = Symbol.for("react.profiler"), f = Symbol.for("react.provider"), u = Symbol.for("react.context"), o = Symbol.for("react.forward_ref"), d = Symbol.for("react.suspense"), l = Symbol.for("react.suspense_list"), g = Symbol.for("react.memo"), v = Symbol.for("react.lazy"), j = Symbol.for("react.offscreen"), I = Symbol.iterator, C = "@@iterator";
    function F(e) {
      if (e === null || typeof e != "object")
        return null;
      var n = I && e[I] || e[C];
      return typeof n == "function" ? n : null;
    }
    var S = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function R(e) {
      {
        for (var n = arguments.length, s = new Array(n > 1 ? n - 1 : 0), m = 1; m < n; m++)
          s[m - 1] = arguments[m];
        N("error", e, s);
      }
    }
    function N(e, n, s) {
      {
        var m = S.ReactDebugCurrentFrame, _ = m.getStackAddendum();
        _ !== "" && (n += "%s", s = s.concat([_]));
        var x = s.map(function(y) {
          return String(y);
        });
        x.unshift("Warning: " + n), Function.prototype.apply.call(console[e], console, x);
      }
    }
    var P = !1, G = !1, L = !1, B = !1, O = !1, k;
    k = Symbol.for("react.module.reference");
    function Y(e) {
      return !!(typeof e == "string" || typeof e == "function" || e === a || e === p || O || e === c || e === d || e === l || B || e === j || P || G || L || typeof e == "object" && e !== null && (e.$$typeof === v || e.$$typeof === g || e.$$typeof === f || e.$$typeof === u || e.$$typeof === o || e.$$typeof === k || e.getModuleId !== void 0));
    }
    function q(e, n, s) {
      var m = e.displayName;
      if (m)
        return m;
      var _ = n.displayName || n.name || "";
      return _ !== "" ? s + "(" + _ + ")" : s;
    }
    function H(e) {
      return e.displayName || "Context";
    }
    function A(e) {
      if (e == null)
        return null;
      if (typeof e.tag == "number" && R("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof e == "function")
        return e.displayName || e.name || null;
      if (typeof e == "string")
        return e;
      switch (e) {
        case a:
          return "Fragment";
        case i:
          return "Portal";
        case p:
          return "Profiler";
        case c:
          return "StrictMode";
        case d:
          return "Suspense";
        case l:
          return "SuspenseList";
      }
      if (typeof e == "object")
        switch (e.$$typeof) {
          case u:
            var n = e;
            return H(n) + ".Consumer";
          case f:
            var s = e;
            return H(s._context) + ".Provider";
          case o:
            return q(e, e.render, "ForwardRef");
          case g:
            var m = e.displayName || null;
            return m !== null ? m : A(e.type) || "Memo";
          case v: {
            var _ = e, x = _._payload, y = _._init;
            try {
              return A(y(x));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var U = Object.assign, X = 0, Ee, we, Ce, Te, Se, ke, Oe;
    function Fe() {
    }
    Fe.__reactDisabledLog = !0;
    function et() {
      {
        if (X === 0) {
          Ee = console.log, we = console.info, Ce = console.warn, Te = console.error, Se = console.group, ke = console.groupCollapsed, Oe = console.groupEnd;
          var e = {
            configurable: !0,
            enumerable: !0,
            value: Fe,
            writable: !0
          };
          Object.defineProperties(console, {
            info: e,
            log: e,
            warn: e,
            error: e,
            group: e,
            groupCollapsed: e,
            groupEnd: e
          });
        }
        X++;
      }
    }
    function tt() {
      {
        if (X--, X === 0) {
          var e = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: U({}, e, {
              value: Ee
            }),
            info: U({}, e, {
              value: we
            }),
            warn: U({}, e, {
              value: Ce
            }),
            error: U({}, e, {
              value: Te
            }),
            group: U({}, e, {
              value: Se
            }),
            groupCollapsed: U({}, e, {
              value: ke
            }),
            groupEnd: U({}, e, {
              value: Oe
            })
          });
        }
        X < 0 && R("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var fe = S.ReactCurrentDispatcher, de;
    function se(e, n, s) {
      {
        if (de === void 0)
          try {
            throw Error();
          } catch (_) {
            var m = _.stack.trim().match(/\n( *(at )?)/);
            de = m && m[1] || "";
          }
        return `
` + de + e;
      }
    }
    var me = !1, ie;
    {
      var rt = typeof WeakMap == "function" ? WeakMap : Map;
      ie = new rt();
    }
    function Pe(e, n) {
      if (!e || me)
        return "";
      {
        var s = ie.get(e);
        if (s !== void 0)
          return s;
      }
      var m;
      me = !0;
      var _ = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var x;
      x = fe.current, fe.current = null, et();
      try {
        if (n) {
          var y = function() {
            throw Error();
          };
          if (Object.defineProperty(y.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(y, []);
            } catch (W) {
              m = W;
            }
            Reflect.construct(e, [], y);
          } else {
            try {
              y.call();
            } catch (W) {
              m = W;
            }
            e.call(y.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (W) {
            m = W;
          }
          e();
        }
      } catch (W) {
        if (W && m && typeof W.stack == "string") {
          for (var b = W.stack.split(`
`), D = m.stack.split(`
`), w = b.length - 1, T = D.length - 1; w >= 1 && T >= 0 && b[w] !== D[T]; )
            T--;
          for (; w >= 1 && T >= 0; w--, T--)
            if (b[w] !== D[T]) {
              if (w !== 1 || T !== 1)
                do
                  if (w--, T--, T < 0 || b[w] !== D[T]) {
                    var M = `
` + b[w].replace(" at new ", " at ");
                    return e.displayName && M.includes("<anonymous>") && (M = M.replace("<anonymous>", e.displayName)), typeof e == "function" && ie.set(e, M), M;
                  }
                while (w >= 1 && T >= 0);
              break;
            }
        }
      } finally {
        me = !1, fe.current = x, tt(), Error.prepareStackTrace = _;
      }
      var K = e ? e.displayName || e.name : "", qe = K ? se(K) : "";
      return typeof e == "function" && ie.set(e, qe), qe;
    }
    function nt(e, n, s) {
      return Pe(e, !1);
    }
    function at(e) {
      var n = e.prototype;
      return !!(n && n.isReactComponent);
    }
    function oe(e, n, s) {
      if (e == null)
        return "";
      if (typeof e == "function")
        return Pe(e, at(e));
      if (typeof e == "string")
        return se(e);
      switch (e) {
        case d:
          return se("Suspense");
        case l:
          return se("SuspenseList");
      }
      if (typeof e == "object")
        switch (e.$$typeof) {
          case o:
            return nt(e.render);
          case g:
            return oe(e.type, n, s);
          case v: {
            var m = e, _ = m._payload, x = m._init;
            try {
              return oe(x(_), n, s);
            } catch {
            }
          }
        }
      return "";
    }
    var ue = Object.prototype.hasOwnProperty, je = {}, Ie = S.ReactDebugCurrentFrame;
    function le(e) {
      if (e) {
        var n = e._owner, s = oe(e.type, e._source, n ? n.type : null);
        Ie.setExtraStackFrame(s);
      } else
        Ie.setExtraStackFrame(null);
    }
    function st(e, n, s, m, _) {
      {
        var x = Function.call.bind(ue);
        for (var y in e)
          if (x(e, y)) {
            var b = void 0;
            try {
              if (typeof e[y] != "function") {
                var D = Error((m || "React class") + ": " + s + " type `" + y + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof e[y] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw D.name = "Invariant Violation", D;
              }
              b = e[y](n, y, m, s, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (w) {
              b = w;
            }
            b && !(b instanceof Error) && (le(_), R("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", m || "React class", s, y, typeof b), le(null)), b instanceof Error && !(b.message in je) && (je[b.message] = !0, le(_), R("Failed %s type: %s", s, b.message), le(null));
          }
      }
    }
    var it = Array.isArray;
    function ve(e) {
      return it(e);
    }
    function ot(e) {
      {
        var n = typeof Symbol == "function" && Symbol.toStringTag, s = n && e[Symbol.toStringTag] || e.constructor.name || "Object";
        return s;
      }
    }
    function ut(e) {
      try {
        return Ne(e), !1;
      } catch {
        return !0;
      }
    }
    function Ne(e) {
      return "" + e;
    }
    function Ae(e) {
      if (ut(e))
        return R("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", ot(e)), Ne(e);
    }
    var Q = S.ReactCurrentOwner, lt = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, De, $e, pe;
    pe = {};
    function ct(e) {
      if (ue.call(e, "ref")) {
        var n = Object.getOwnPropertyDescriptor(e, "ref").get;
        if (n && n.isReactWarning)
          return !1;
      }
      return e.ref !== void 0;
    }
    function ft(e) {
      if (ue.call(e, "key")) {
        var n = Object.getOwnPropertyDescriptor(e, "key").get;
        if (n && n.isReactWarning)
          return !1;
      }
      return e.key !== void 0;
    }
    function dt(e, n) {
      if (typeof e.ref == "string" && Q.current && n && Q.current.stateNode !== n) {
        var s = A(Q.current.type);
        pe[s] || (R('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', A(Q.current.type), e.ref), pe[s] = !0);
      }
    }
    function mt(e, n) {
      {
        var s = function() {
          De || (De = !0, R("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", n));
        };
        s.isReactWarning = !0, Object.defineProperty(e, "key", {
          get: s,
          configurable: !0
        });
      }
    }
    function vt(e, n) {
      {
        var s = function() {
          $e || ($e = !0, R("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", n));
        };
        s.isReactWarning = !0, Object.defineProperty(e, "ref", {
          get: s,
          configurable: !0
        });
      }
    }
    var pt = function(e, n, s, m, _, x, y) {
      var b = {
        $$typeof: t,
        type: e,
        key: n,
        ref: s,
        props: y,
        _owner: x
      };
      return b._store = {}, Object.defineProperty(b._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(b, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: m
      }), Object.defineProperty(b, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: _
      }), Object.freeze && (Object.freeze(b.props), Object.freeze(b)), b;
    };
    function ht(e, n, s, m, _) {
      {
        var x, y = {}, b = null, D = null;
        s !== void 0 && (Ae(s), b = "" + s), ft(n) && (Ae(n.key), b = "" + n.key), ct(n) && (D = n.ref, dt(n, _));
        for (x in n)
          ue.call(n, x) && !lt.hasOwnProperty(x) && (y[x] = n[x]);
        if (e && e.defaultProps) {
          var w = e.defaultProps;
          for (x in w)
            y[x] === void 0 && (y[x] = w[x]);
        }
        if (b || D) {
          var T = typeof e == "function" ? e.displayName || e.name || "Unknown" : e;
          b && mt(y, T), D && vt(y, T);
        }
        return pt(e, b, D, _, m, Q.current, y);
      }
    }
    var he = S.ReactCurrentOwner, Le = S.ReactDebugCurrentFrame;
    function J(e) {
      if (e) {
        var n = e._owner, s = oe(e.type, e._source, n ? n.type : null);
        Le.setExtraStackFrame(s);
      } else
        Le.setExtraStackFrame(null);
    }
    var be;
    be = !1;
    function ge(e) {
      return typeof e == "object" && e !== null && e.$$typeof === t;
    }
    function Me() {
      {
        if (he.current) {
          var e = A(he.current.type);
          if (e)
            return `

Check the render method of \`` + e + "`.";
        }
        return "";
      }
    }
    function bt(e) {
      {
        if (e !== void 0) {
          var n = e.fileName.replace(/^.*[\\\/]/, ""), s = e.lineNumber;
          return `

Check your code at ` + n + ":" + s + ".";
        }
        return "";
      }
    }
    var We = {};
    function gt(e) {
      {
        var n = Me();
        if (!n) {
          var s = typeof e == "string" ? e : e.displayName || e.name;
          s && (n = `

Check the top-level render call using <` + s + ">.");
        }
        return n;
      }
    }
    function Ve(e, n) {
      {
        if (!e._store || e._store.validated || e.key != null)
          return;
        e._store.validated = !0;
        var s = gt(n);
        if (We[s])
          return;
        We[s] = !0;
        var m = "";
        e && e._owner && e._owner !== he.current && (m = " It was passed a child from " + A(e._owner.type) + "."), J(e), R('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', s, m), J(null);
      }
    }
    function ze(e, n) {
      {
        if (typeof e != "object")
          return;
        if (ve(e))
          for (var s = 0; s < e.length; s++) {
            var m = e[s];
            ge(m) && Ve(m, n);
          }
        else if (ge(e))
          e._store && (e._store.validated = !0);
        else if (e) {
          var _ = F(e);
          if (typeof _ == "function" && _ !== e.entries)
            for (var x = _.call(e), y; !(y = x.next()).done; )
              ge(y.value) && Ve(y.value, n);
        }
      }
    }
    function yt(e) {
      {
        var n = e.type;
        if (n == null || typeof n == "string")
          return;
        var s;
        if (typeof n == "function")
          s = n.propTypes;
        else if (typeof n == "object" && (n.$$typeof === o || n.$$typeof === g))
          s = n.propTypes;
        else
          return;
        if (s) {
          var m = A(n);
          st(s, e.props, "prop", m, e);
        } else if (n.PropTypes !== void 0 && !be) {
          be = !0;
          var _ = A(n);
          R("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", _ || "Unknown");
        }
        typeof n.getDefaultProps == "function" && !n.getDefaultProps.isReactClassApproved && R("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function _t(e) {
      {
        for (var n = Object.keys(e.props), s = 0; s < n.length; s++) {
          var m = n[s];
          if (m !== "children" && m !== "key") {
            J(e), R("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", m), J(null);
            break;
          }
        }
        e.ref !== null && (J(e), R("Invalid attribute `ref` supplied to `React.Fragment`."), J(null));
      }
    }
    function Ye(e, n, s, m, _, x) {
      {
        var y = Y(e);
        if (!y) {
          var b = "";
          (e === void 0 || typeof e == "object" && e !== null && Object.keys(e).length === 0) && (b += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var D = bt(_);
          D ? b += D : b += Me();
          var w;
          e === null ? w = "null" : ve(e) ? w = "array" : e !== void 0 && e.$$typeof === t ? (w = "<" + (A(e.type) || "Unknown") + " />", b = " Did you accidentally export a JSX literal instead of a component?") : w = typeof e, R("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", w, b);
        }
        var T = ht(e, n, s, _, x);
        if (T == null)
          return T;
        if (y) {
          var M = n.children;
          if (M !== void 0)
            if (m)
              if (ve(M)) {
                for (var K = 0; K < M.length; K++)
                  ze(M[K], e);
                Object.freeze && Object.freeze(M);
              } else
                R("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              ze(M, e);
        }
        return e === a ? _t(T) : yt(T), T;
      }
    }
    function xt(e, n, s) {
      return Ye(e, n, s, !0);
    }
    function Rt(e, n, s) {
      return Ye(e, n, s, !1);
    }
    var Et = Rt, wt = xt;
    te.Fragment = a, te.jsx = Et, te.jsxs = wt;
  }()), te;
}
(function(r) {
  process.env.NODE_ENV === "production" ? r.exports = $t() : r.exports = Lt();
})(ce);
const Z = ce.exports.Fragment, h = ce.exports.jsx, $ = ce.exports.jsxs, He = (r) => {
  var i;
  const t = () => /* @__PURE__ */ h("button", {
    className: r.classes ? r.classes.join(" ") : void 0,
    type: r.type,
    children: r.text
  });
  return /* @__PURE__ */ h(Z, {
    children: (i = r.prefix) != null && i.tag ? Re(t(), r.prefix) : t()
  });
}, Mt = (r) => {
  var i;
  const t = () => {
    var a, c, p, f, u, o, d, l;
    return /* @__PURE__ */ $(Z, {
      children: [/* @__PURE__ */ h(He, {
        type: "submit",
        prefix: (a = r.btnSubmit) == null ? void 0 : a.prefix,
        classes: (c = r.btnSubmit) == null ? void 0 : c.classes,
        text: (f = (p = r.btnSubmit) == null ? void 0 : p.text) != null ? f : "Submit"
      }), /* @__PURE__ */ h(He, {
        type: "reset",
        prefix: (u = r.btnReset) == null ? void 0 : u.prefix,
        classes: (o = r.btnReset) == null ? void 0 : o.classes,
        text: (l = (d = r.btnReset) == null ? void 0 : d.text) != null ? l : "Reset"
      })]
    });
  };
  return /* @__PURE__ */ h(Z, {
    children: (i = r.prefix) != null && i.tag ? Re(t(), r.prefix) : t()
  });
}, Wt = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var f;
  const [a, c] = E((f = t.value) != null ? f : "");
  z(() => {
    var u;
    c((u = t.value) != null ? u : "");
  }, [t.value]);
  const p = async (u) => {
    const o = t.attributes.type === "number" ? parseInt(u.currentTarget.value) : u.currentTarget.value;
    c(o);
    const d = {
      form_name: r,
      field_name: t.name,
      value: o
    };
    i(d);
  };
  return /* @__PURE__ */ h("input", {
    type: t.attributes.type ? t.attributes.type : "text",
    name: t.name,
    value: a,
    id: t.attributes.id ? t.attributes.id : t.name,
    className: t.attributes.classes ? t.attributes.classes.join(" ") : void 0,
    placeholder: t.attributes.placeholder,
    required: ae(t),
    disabled: t.attributes.disabled,
    readOnly: t.attributes.readonly,
    min: t.attributes.min,
    max: t.attributes.max,
    step: t.attributes.step,
    autoComplete: t.attributes.autocomplete,
    onChange: p
  });
}, Vt = V(Wt), zt = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var o;
  const [a, c] = E((o = t.value) != null ? o : ""), [p, f] = E(!1);
  z(() => {
    var d;
    if (t.extra) {
      const l = t.extra.multiple ? t.extra.multiple : !1;
      f(l);
    }
    c((d = t.value) != null ? d : "");
  }, [t.value]);
  const u = async (d) => {
    let l;
    if (p) {
      let v = [];
      const j = d.currentTarget.selectedOptions;
      for (let I = 0; I < j.length; I++) {
        const C = j[I].value;
        v = [...v, ...C];
      }
      l = v;
    } else
      l = d.currentTarget.value;
    c(l);
    const g = {
      form_name: r,
      field_name: t.name,
      value: l
    };
    i(g);
  };
  return /* @__PURE__ */ h("select", {
    name: t.name,
    value: a,
    id: t.attributes.id,
    className: t.attributes.classes ? t.attributes.classes.join(" ") : void 0,
    required: ae(t),
    disabled: t.attributes.disabled,
    multiple: p,
    onChange: u,
    children: (t.extra.options || []).map((d) => /* @__PURE__ */ h("option", {
      value: d.value,
      children: d.title
    }, d.value))
  });
}, Yt = V(zt), qt = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var d;
  const a = Ke(null), [c] = E((d = t.extra.multiple) != null ? d : !1), [p, f] = E([]);
  z(() => {
    (!t.value || !t.value.length) && f([]);
  }, [t.value]);
  const u = async (l) => {
    let g = l.target.files || [];
    if (g = Array.from(g), f(g), g.length > 0) {
      const v = {
        form_name: r,
        field_name: t.name,
        value: g
      };
      i(v);
    }
  }, o = (l, g) => {
    l.preventDefault();
    let v;
    const j = p.filter((C) => C.name != g.name);
    p.length === 0 ? (a && a.current && (a.current.value = ""), v = null) : v = j, f(v);
    const I = {
      form_name: r,
      field_name: t.name,
      value: v
    };
    i(I);
  };
  return /* @__PURE__ */ $(ne, {
    children: [/* @__PURE__ */ h("input", {
      type: "file",
      name: t.name,
      id: t.attributes.id,
      className: t.attributes.classes ? t.attributes.classes.join(" ") : void 0,
      multiple: c,
      onChange: u,
      ref: a,
      required: ae(t)
    }), p.length > 0 && t.extra.showPreview ? p.map((l, g) => /* @__PURE__ */ $("div", {
      className: "file",
      children: [/* @__PURE__ */ h("div", {
        className: "img",
        children: /* @__PURE__ */ h("img", {
          src: window.URL.createObjectURL(l),
          alt: l.name
        })
      }), /* @__PURE__ */ h("div", {
        className: "infos",
        children: /* @__PURE__ */ $("ul", {
          children: [/* @__PURE__ */ $("li", {
            children: ["Name: ", l.name]
          }), /* @__PURE__ */ $("li", {
            children: ["Size: ", l.size]
          }), /* @__PURE__ */ $("li", {
            children: ["Type: ", l.type]
          }), /* @__PURE__ */ h("li", {
            children: /* @__PURE__ */ h("button", {
              type: "button",
              onClick: (v) => o(v, l),
              className: "btn",
              children: "Remove"
            })
          })]
        })
      })]
    }, g)) : ""]
  });
}, Bt = V(qt), Ut = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var f;
  const [a, c] = E((f = t.value) != null ? f : "");
  z(() => {
    var u;
    c((u = t.value) != null ? u : "");
  }, [t.value]);
  const p = async (u) => {
    const o = u.currentTarget.value;
    c(o);
    const d = {
      form_name: r,
      field_name: t.name,
      value: o
    };
    i(d);
  };
  return /* @__PURE__ */ h("textarea", {
    name: t.name,
    className: t.attributes.classes ? t.attributes.classes.join(" ") : void 0,
    value: a,
    placeholder: t.attributes.placeholder,
    required: ae(t),
    disabled: t.attributes.disabled,
    readOnly: t.attributes.readonly,
    rows: t.attributes.rows,
    cols: t.attributes.cols,
    onInput: p
  });
}, Gt = V(Ut), Ht = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var o, d;
  const [a, c] = E((o = t.extra.items) != null ? o : []), [p, f] = E((d = t.value) != null ? d : []);
  z(() => {
    var g;
    const l = t.extra.items.map((v) => (t.value && t.value.includes(v.value) ? v.checked = !0 : v.checked = !1, v));
    c(l), f((g = t.value) != null ? g : []);
  }, [t.extra.items, t.value]);
  const u = async (l) => {
    const g = l.currentTarget.value;
    let v = p;
    l.currentTarget.checked ? v = [...v, g] : v = v.filter((I) => {
      if (I !== g)
        return I;
    }), f(v);
    const j = {
      form_name: r,
      field_name: t.name,
      value: v
    };
    i(j);
  };
  return /* @__PURE__ */ h(ne, {
    children: a && a.map((l) => /* @__PURE__ */ $(ne, {
      children: [/* @__PURE__ */ h("input", {
        type: t.type,
        id: t.attributes.id ? t.attributes.id : t.name,
        className: t.attributes.classes ? t.attributes.classes.join(" ") : void 0,
        value: l.value,
        name: l.name,
        defaultChecked: l.value ? l.checked : !1,
        onInput: u
      }), /* @__PURE__ */ h("span", {
        children: l.title
      })]
    }, l.title))
  });
}, Jt = V(Ht), Kt = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var f;
  const [a, c] = E((f = t.extra.items) != null ? f : null);
  z(() => {
    const u = t.extra.items.map((o) => (t.value === o.value ? o.checked = !0 : o.checked = !1, o));
    c(u);
  }, [t, t.value, t.extra.items]);
  const p = async (u) => {
    const o = u.currentTarget.value, d = {
      form_name: r,
      field_name: t.name,
      value: o
    };
    i(d);
  };
  return /* @__PURE__ */ h(ne, {
    children: a && a.map((u) => /* @__PURE__ */ $(ne, {
      children: [/* @__PURE__ */ h("input", {
        type: t.type,
        id: u.id,
        className: t.attributes.classes ? t.attributes.classes.join(" ") : void 0,
        value: u.value,
        name: t.name,
        defaultChecked: u.value ? u.checked : !1,
        onInput: p
      }), /* @__PURE__ */ h("span", {
        children: u.title
      })]
    }, u.title))
  });
}, Zt = V(Kt), Xt = ({
  error: r,
  messages: t
}) => {
  const i = [{
    rule: "required",
    message: "This field is required"
  }, {
    rule: "min",
    message: "This field must be more characters long"
  }, {
    rule: "max",
    message: "This field must be less characters long"
  }, {
    rule: "between",
    message: "This field must be between values defined"
  }, {
    rule: "equal",
    message: "This field must be equal to value defined"
  }, {
    rule: "email",
    message: "This email format is not valid"
  }, {
    rule: "extensions",
    message: "Must to allowed file types"
  }, {
    rule: "maxSize",
    message: "This file has size more than max size"
  }, {
    rule: "custom_rule",
    message: "Error"
  }], a = (f) => {
    const u = i.find((o) => o.rule === f);
    return u ? u.message : i.find((o) => o.rule === "custom_rule").message;
  }, c = (f) => {
    var o;
    let u = "";
    return t[f] ? u += (o = t[f]) != null ? o : a(f) : u += a(f), u;
  };
  return (() => /* @__PURE__ */ h("div", {
    className: "invalid-feedback error",
    children: c(r)
  }))();
}, Qt = (r) => {
  const t = re.useRef();
  return re.useEffect(() => {
    const i = (a) => {
      t.current && !t.current.contains(a.target) && r();
    };
    return document.addEventListener("click", i), () => {
      document.removeEventListener("click", i);
    };
  }, []), t;
}, er = {
  position: "relative",
  width: "100%"
}, tr = {
  marginBottom: "10px",
  width: "100%",
  display: "flex",
  flexWrap: "wrap",
  justifyContent: "flex-start",
  alignContent: "flex-start",
  gap: "10px"
}, rr = {
  fontSize: "0.75rem",
  padding: "0.4rem",
  backgroundColor: "#ff3e00",
  color: "white",
  borderRadius: "5px"
}, nr = {
  cursor: "pointer",
  borderRadius: "50%",
  width: "15px",
  height: "15px",
  padding: "2px 7px 3px 7px",
  marginLeft: "7px",
  fontSize: "0.6rem",
  backgroundColor: "red",
  border: "solid 1px rgba(255, 255, 255, 0.2)",
  color: "white"
}, ar = {
  boxShadow: "0 2px 3px 0 rgba(249, 251, 253, 0.24)",
  marginBottom: "20px"
}, xe = {
  listStyle: "none",
  padding: "0",
  margin: "0",
  color: "black",
  backgroundColor: "rgb(201, 201, 201)"
}, Je = {
  padding: "0.75rem",
  cursor: "pointer"
}, sr = {
  backgroundColor: "#ff40009c",
  color: "white"
}, ir = {
  backgroundColor: "#1f2d38",
  borderBottomColor: "transparent",
  color: "white",
  textAlign: "center"
}, or = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var L, B;
  const [a, c] = E(""), [p, f] = E([]), [u, o] = E([]), [d, l] = E([]), [g, v] = E(!1), [j, I] = E((B = (L = t.extra) == null ? void 0 : L.filter_lenght) != null ? B : 0), [C, F] = E({
    hover: !1,
    indx: -1
  });
  z(() => {
    c(t.value ? a : ""), l(!t.value || t.value.length === 0 ? [] : t.value), t.extra && (t.extra.loadItemes && f(t.extra.loadItemes), t.extra.filter_length && I(t.extra.filter_length));
  }, [t.extra, t.value]);
  const S = async (O) => {
    const k = O.currentTarget.value;
    if (c(k), k.length >= j) {
      const Y = p.filter((q) => q.title.toLowerCase().includes(k.toLowerCase()));
      Y.length ? (o(Y), v(!0)) : (o([]), v(!1));
    } else
      v(!1);
  }, R = (O) => () => {
    const k = p.filter((A) => A.value !== O.value);
    f(k);
    const Y = u.filter((A) => A.value !== O.value);
    o(Y);
    const q = [...d, O];
    l(q), k.length || v(!1);
    const H = {
      form_name: r,
      field_name: t.name,
      value: q
    };
    i(H);
  }, N = (O) => async () => {
    const k = await d.filter((A) => A.value !== O.value);
    l(k);
    const Y = [...p, O];
    f(Y);
    const q = [...u, O];
    o(q);
    const H = {
      form_name: r,
      field_name: t.name,
      value: k
    };
    i(H);
  }, G = Qt(() => {
    v(!1);
  });
  return /* @__PURE__ */ $("div", {
    className: "autocomplete-wrapper",
    style: er,
    children: [/* @__PURE__ */ h("div", {
      className: "selected-items",
      style: tr,
      children: d && d.map((O, k) => /* @__PURE__ */ $("div", {
        className: "item",
        style: {
          ...rr
        },
        children: [/* @__PURE__ */ h("span", {
          children: O.title
        }), /* @__PURE__ */ h("span", {
          className: "deselect",
          style: nr,
          onClick: N(O),
          children: "x"
        })]
      }, k))
    }), /* @__PURE__ */ h("input", {
      type: t.attributes.type ? t.attributes.type : "text",
      name: t.name,
      value: a,
      id: t.attributes.id ? t.attributes.id : t.name,
      className: t.attributes.classes ? t.attributes.classes.join(" ") : "",
      placeholder: t.attributes.placeholder,
      required: ae(t),
      disabled: t.attributes.disabled,
      readOnly: t.attributes.readonly,
      min: t.attributes.min,
      max: t.attributes.max,
      step: t.attributes.step,
      autoCorrect: t.attributes.autocorrect,
      autoComplete: t.attributes.autocomplete,
      onInput: S
    }), u.length > 0 && g && /* @__PURE__ */ h("div", {
      ref: G,
      className: "list-items",
      style: ar,
      children: /* @__PURE__ */ $("ul", {
        style: xe,
        children: [u.map((O, k) => /* @__PURE__ */ h("li", {
          onMouseEnter: () => {
            F({
              hover: !0,
              indx: k
            });
          },
          onMouseLeave: () => {
            F({
              hover: !1,
              indx: k
            });
          },
          style: {
            ...xe,
            ...Je,
            ...k === C.indx && C.hover ? sr : null
          },
          onClick: R(O),
          children: O.title
        }, k)), /* @__PURE__ */ h("li", {
          style: {
            ...xe,
            ...Je,
            ...ir
          },
          className: "done",
          onClick: () => {
            v(!1), c("");
          },
          children: "Close"
        })]
      })
    })]
  });
}, ur = V(or), lr = {
  input: Vt,
  select: Yt,
  file: Bt,
  textarea: Gt,
  checkbox: Jt,
  radio: Zt,
  autocomplete: ur
}, cr = ({
  form_name: r,
  field: t,
  changeValue: i
}) => {
  var d;
  const [a, c] = E(t), p = lr[t.type];
  z(() => {
    c(t);
  }, [t]);
  const f = (l) => {
    i(l);
  }, u = () => /* @__PURE__ */ $(Z, {
    children: [a.attributes.label && /* @__PURE__ */ h("label", {
      htmlFor: a.attributes.id,
      children: a.attributes.label
    }), /* @__PURE__ */ h(p, {
      form_name: r,
      field: a,
      changeValue: f
    }, a.name), o()]
  }), o = () => {
    if (a.validation && a.validation.errors.length)
      return a.validation.errors.map((l, g) => /* @__PURE__ */ h(Xt, {
        error: l,
        messages: a.messages ? a.messages : []
      }, g));
  };
  return /* @__PURE__ */ h(Z, {
    children: (d = a.prefix) != null && d.tag ? Re(u(), a.prefix) : u()
  });
}, fr = V(cr), dr = (r) => {
  const t = Ke(), [i, a] = E([]), [c, p] = E({
    form_name: r.form_name,
    fields: r.fields,
    values: {},
    valid: !0
  }), [f, u] = E(r.fields), [o, d] = E({}), [l, g] = E(!1);
  z(() => {
    const C = Dt(r.fields);
    g(C);
    async function F() {
      var G;
      let S = (G = c.values) != null ? G : {};
      const R = await Promise.all(r.fields.map(async (L) => {
        var B;
        return S[`${L.name}`] = (B = L.value) != null ? B : null, L = await _e(c, L, S), L;
      }));
      u(R);
      const N = R.find((L) => L.validation ? L.validation.dirty === !0 : !1);
      d(S);
      const P = {
        ...c,
        fields: R,
        values: S,
        valid: !N
      };
      p(P), a(await ye(i, P)), r.get_values && r.get_values(o);
    }
    F();
  }, [r.fields]);
  const v = async (C) => {
    let F = c.values;
    const S = await Promise.all(c.fields.map(async (P) => (P.name === C.field_name && (F.touched = P.name, P.value = C.value, F[`${P.name}`] = C.value), P = await _e(c, P, F), P))), R = S.find((P) => P.validation ? P.validation.dirty === !0 : !1);
    d(F);
    const N = {
      ...c,
      fields: S,
      values: F,
      valid: !R
    };
    p(N), a(await ye(i, N)), r.get_values && r.get_values(o), r.onChange && r.onChange({
      form_name: r.form_name,
      values: c.values,
      valid: N.valid
    });
  }, j = async (C) => {
    C.preventDefault(), r.onSubmit && r.onSubmit({
      values: c.values,
      valid: c.valid
    });
  }, I = async (C) => {
    t.current.reset();
    let F = {}, S = await Promise.all(c.fields.map(async (N) => (N.value = null, F[N.name] = null, N = await _e(c, N, F), N)));
    const R = {
      ...c,
      fields: S,
      values: F
    };
    u(S), p(R), a(await ye(i, R)), r.get_values && r.get_values(o);
  };
  return /* @__PURE__ */ h(Z, {
    children: l ? /* @__PURE__ */ h("p", {
      children: /* @__PURE__ */ h("code", {
        children: /* @__PURE__ */ h("b", {
          children: "Error!s Detect duplicate fields(name or id attributes), make sure you put unique name and id for each field."
        })
      })
    }) : /* @__PURE__ */ $("form", {
      className: r.classes ? r.classes.join(" ") : void 0,
      ref: t,
      onSubmit: j,
      onReset: I,
      children: [c.fields.map((C) => /* @__PURE__ */ h(fr, {
        form_name: r.form_name,
        field: C,
        changeValue: v
      }, C.name)), /* @__PURE__ */ h(Mt, {
        prefix: r.buttonsAction,
        btnSubmit: r.btnSubmit,
        btnReset: r.btnReset
      })]
    })
  });
}, hr = V(dr);
export {
  hr as Formly,
  Vt as Input,
  pr as clickOutside,
  Re as createComponentWithPrefix,
  vr as inArray,
  Dt as isFieldDuplicated,
  ae as isRequired,
  At as preprocessField,
  _e as preprocess_and_validate_field,
  ye as saveForm,
  Nt as validate
};
