import React from "react";
import type { IField } from "./types";
export declare function inArray(arr: Array<any>, element: any): boolean;
export declare function isRequired(field: IField): boolean;
export declare function isFieldDuplicated(fields: IField[]): boolean;
export declare function clickOutside(node: any): {
    destroy(): void;
};
export declare function createComponentWithPrefix(children: JSX.Element, props: {
    tag?: string;
    classes?: string[];
}): React.ReactElement<{
    className: string | undefined;
}, string | React.JSXElementConstructor<any>>;
